####################################################################
#                                                                  #
# NAME:     Sample Solution                                        #
#                                                                  #
####################################################################
#====================================================================
#       Static data allocation and initialization
#====================================================================
.data
size:	.word 16
arr:	.word 1, 2, 3, 4, 5, 6, 7, -8, -7, -6, -5, -4, -3, -2, -1, 0

larger:	.asciiz "There are "
finish:	.asciiz " elements larger than "
single:	.asciiz "There is 1 element larger than "
min:	.asciiz ".\nThe minimum element is "
max:	.asciiz ".\nThe maximum element is "
mean:	.asciiz ".\nThe integer average is "
done:	.asciiz ".\n"

#====================================================================
#       Program text
#====================================================================

.text
.globl main

main:
# Register usage:
# $t0:	int *a, the pointer to the next array element
# $t1:	int v, the value of the current element
# $t2:	int s, the size of the array
# $t3:	int L, the last element's value
# $t4:	int n, the number of elements larger than L
# $t5:	int m, the min element
# $t6:	int M, the max element
# $t7:	int sum, the sum of all of the elements so far
# $t8:	temp
# $t9:	size of the array for the average

# Init all the registers.
		la $t0, arr				# a = arr
		lw $t2, size			# s = *size
		move $t9, $t2			# t9 = s
		sll $t8, $t2, 2			# temp = s * 4
		add $t8, $t0, $t8		# temp <- address of last element + 4
		lw $t3, -4($t8)			# L = *(temp-1)
		li $t4, 0				# n = 0
		lui $t5, 0x7FFF			# m = 0x7FFF << 16
		ori $t5, 0xFFFF			# m |= 0xFFFF, largest positive
# I'm being tricky here. I'm using unsigned addition to take me from the
# largest positive number to the smallest negative number
		addiu $t6, $t5, 1		# M = 0x8000 0000, largest negative
		li $t7, 0				# sum = 0

# Loop through the array and get the results
top:	beqz $t2, end			# if (s == 0) goto end
		lw $t1, 0($t0)			# v = *a
		addiu $t0, $t0, 4		# ++a
		addi $t2, $t2, -1		# --s
		# Check if the value is less than the last value in the array.
		ble $t1, $t3, step2		# if (v <= L) goto step2
		addi $t4, $t4, 1		# ++n
		# Check for the minimum value.
step2:	bge $t1, $t5, step3		# if (v >= m) goto step3
		move $t5, $t1			# m = v
		# Check for the maximum value.
step3:	ble $t1, $t6, step4		# if (v <= M) goto step4
		move $t6, $t1			# M = v
		# Add the value to the running sum.
step4:	add $t7, $t7, $t1		# sum += v
		b top					# goto top

# Now we've finished looking at the array, get the average and put it in $t7.
# Then print out the results, in correct english.
end:	div $t7, $t7, $t9		# sum /= sizeof(arr)

		li $t8, 1				# temp = 1
		li $v0, 4				# print string
		bne $t4, $t8, plural	# if (n != 1) goto plural
		la $a0, single			# just one element
		syscall					# print it
		b skip					# goto skip
plural:	la $a0, larger			# first part of string larger
		syscall					# print it
		li $v0, 1				# print int
		move $a0, $t4			# n
		syscall					# print it
		li $v0, 4				# print string
		la $a0, finish			# last part of string larger
		syscall					# print it
skip:	li $v0, 1				# print int
		move $a0, $t3			# L
		syscall					# print it
		li $v0, 4				# print string
		la $a0, min				# string min
		syscall					# print it
		li $v0, 1				# print int
		move $a0, $t5			# m
		syscall					# print it
		li $v0, 4				# print string
		la $a0, max				# string max
		syscall					# print it
		li $v0, 1				# print int
		move $a0, $t6			# M
		syscall					# print it
		li $v0, 4				# print string
		la $a0, mean			# string mean
		syscall					# print it
		li $v0, 1				# print int
		move $a0, $t7			# sum (now average)
		syscall					# print it
		li $v0, 4				# print string
		la $a0, done			# clean up string
		syscall					# you guessed it, print it

		jr      $ra             # return
.end main
