
.data						# Tells assembler that this is data
message: 
  .asciiz "The 10th fibonacci number is: "
newline: 
  .asciiz "\n"

.text 						# Tells the assembler that the following is code
.globl main					# Entry into our code must be global

main: 
subu $sp, 12					# Allocate 3 words of storage space on stack
sw $31, 0($sp)					# Save the return address (to caller of main)

li $14, 1					# Put a constant 1 into temporary register 14
sw $14, 4($sp)					# Put a 1 into our two words of temporary storage
sw $14, 8($sp)					# Stores c-equivalent of fib1 and fib2

li $8, 3					# Our iteration counter starts at 3 because
						#  the first two numbers are one (loaded above)

loop: 						# Label denoting a position of code named "loop"
lw $24, 4($sp)					# Put fib1 into register 24
lw $25, 8($sp)					# Put fib2 into register 25
addu $25, $25, $24				# Put next fibonacci number into register 25
sw $24, 8($sp)					# Put fib1 into storage reserved for fib2
sw $25, 4($sp)					# Put the new fibonacci number into fib1
addu $8, $8, 1					# Increment the counter
ble $8, 10, loop				# If counter $8 <= 10, go to loop

						# fib1 [4($sp)] now has our 10th fibonacci number

li $2, 4					# Use syscall 4 (print_string)
la $4, message					# Load address of string "message" in .data section
syscall 					# Print the message
	
li $2, 1					# Use syscall 1 (print_int)
lw $4, 4($sp)					# Load the number 
syscall						# Print the number

li $2, 4
la $4, newline
syscall

lw $31, 0($sp)					# Get return address
addu $sp, 12					# Restore stack pointer
j $31						# Return to caller

.end main 